#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "EmonLib.h"
#include <EEPROM.h>
LiquidCrystal_I2C _lcd1(0x27, 16, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;


bool _FreeLog1_IArr[3];
bool _FreeLog1_Q1_StArr[] = {1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1};
float Irms_120491848_1;
float Power_120491848_1;
EnergyMonitor emon1_120491848_1; // Create an instance
bool Key_235650101_1;
bool Long_235650101_1;
bool Short_235650101_1;
bool oldkey_235650101_1;
bool K_FL_235650101_1;
unsigned long oldtime_235650101_1;
unsigned long deltatime_235650101_1;
unsigned long keytime_235650101_1;
float Temperature_168854444_1;
uint16_t tempADC_168854444_1;
int16_t calcT_168854444_1;
uint32_t Rsamples_168854444_1[ 10 ]; 
uint32_t Raverage_168854444_1;
uint8_t count_168854444_1=0;
uint8_t index_168854444_1=0;
const PROGMEM uint32_t table_168854444_1[] = { 32330, 25194, 19785, 15651, 12468, 10000, 8072, 6400, 5356, 4401, 3600, 2988, 2489, 2083, 1752, 1481, 1257, 1063, 917, 788, 679 } ;
const byte _menuParametrsArray[]  PROGMEM =  {1, 7, 2, 0, 0, 0, 2, 3, 1, 1, 4, 0, 2, 7, 1, 0, 0, 0, 2, 3, 1, 1, 3, 0, 3, 1, 2, 0, 0, 0, 2, 1, 1, 4, 2, 0, 4, 1, 1, 0, 0, 0, 2, 3, 1, 4, 1, 0};
int _menuValueArray_int[2];
const int _menuConstantValuesArray_int[]  PROGMEM =  {1, 99, 0};
float _menuValueArray_float[2];
const float _menuConstantValuesArray_float[]  PROGMEM =  {0.1, 99, 1};
 const char _flprogMenuNameString1[] PROGMEM = "Temp";
 const char _flprogMenuNameString2[] PROGMEM = "Delay";
 const char _flprogMenuNameString3[] PROGMEM = "Min";
 const char _flprogMenuNameString4[] PROGMEM = "Max";
const char* const _flprogMenuStringsArray[] PROGMEM = { _flprogMenuNameString1,  _flprogMenuNameString2,  _flprogMenuNameString3,  _flprogMenuNameString4};
struct _menuItemStricture {
 int startInArrayIndex;
};
struct _menuMainStricture {
 byte startIndex;
 byte stopIndex;
 bool isSwitchMenuAroundRing;
_menuItemStricture  currentItem;
};
_menuItemStricture _MenuItems[4];
_menuMainStricture _MainMenus[1];
bool _gtv2;
bool _gtv1;
bool _gtv3;
bool _gtv4;
bool _gtv5;
int _gtv6;
bool _tim4I = 0;
bool _tim4O = 0;
unsigned long _tim4P = 0UL;
int _disp4oldLength = 0;
bool _bounseInputD2S = 0;
bool _bounseInputD2O = 0;
unsigned long _bounseInputD2P = 0UL;
int _disp3oldLength = 0;
bool _FreeLog1_Q1 = 0;
bool _tim1I = 0;
bool _tim1O = 0;
unsigned long _tim1P = 0UL;
int _disp11oldLength = 0;
int _disp9oldLength = 0;
int _disp7oldLength = 0;
int _disp14oldLength = 0;
int _disp16oldLength = 0;
bool _trgs4 = 0;
bool _bounseInputD4S = 0;
bool _bounseInputD4O = 0;
unsigned long _bounseInputD4P = 0UL;
bool _tim2I = 0;
bool _tim2O = 0;
unsigned long _tim2P = 0UL;
bool _trgt1 = 0;
bool _trgt1I = 0;
int _disp2oldLength = 0;
int _disp10oldLength = 0;
int _disp1oldLength = 0;
int _disp6oldLength = 0;
int _disp8oldLength = 0;
bool _trgs1 = 0;
bool _trgs2 = 0;
int _disp15oldLength = 0;
bool _trgs3 = 0;
int _disp12oldLength = 0;
int _disp13oldLength = 0;
bool _MenuBlock_118425010_AMO_310615098 = 0;
bool _MenuBlock_118425010_AMO_209567261 = 0;
bool _MenuBlock_118425010_AMO_355910277 = 0;
bool _MenuBlock_118425010_AMO_375957480 = 0;
String _MenuBlock_118425010_MNO;
String _MenuBlock_118425010_VNO;
bool _MenuBlock_118425010_OEIS = 0;
bool _MenuBlock_118425010_OMUIS = 0;
bool _MenuBlock_118425010_OMDIS = 0;
bool _MenuBlock_118425010_OVUIS = 0;
bool _MenuBlock_118425010_OVDIS = 0;
unsigned long _MenuBlock_118425010_VUDST = 0UL;
unsigned long _MenuBlock_118425010_VUDSPT = 0UL;
byte _MenuBlock_118425010_VUDSM = 0;
int _MenuBlock_118425010_VUDPT = 0;
int _disp17oldLength = 0;
bool _tim3I = 0;
bool _tim3O = 0;
unsigned long _tim3P = 0UL;
bool _bounseInputD3S = 0;
bool _bounseInputD3O = 0;
unsigned long _bounseInputD3P = 0UL;
int _disp5oldLength = 0;
void setup()
{
Wire.begin();
delay(10);
if(((readByteFromEEPROM(0, 0, 0x0))) != 185) {
(updateByteToEEPROM(0, 0, 0x0, (185)));
(updateIntegerToEEPROM(1, 0, 0x0, (30)));
(updateIntegerToEEPROM(3, 0, 0x0, (5)));
(updateFloatToEEPROM(5, 0, 0x0, (1)));
(updateFloatToEEPROM(9, 0, 0x0, (10)));
}
pinMode(2, INPUT_PULLUP); 
pinMode(3, INPUT_PULLUP); 
pinMode(4, INPUT_PULLUP); 
pinMode(13, OUTPUT); 

_lcd1.init();
_lcd1.backlight();
_bounseInputD4O =  digitalRead(4);
_bounseInputD3O =  digitalRead(3);
_bounseInputD2O =  digitalRead(2);
Serial.begin(9600);
  
emon1_120491848_1.current(0, 18.5); 
oldkey_235650101_1=false;
oldtime_235650101_1=0;

 _MenuItems[0].startInArrayIndex = 0;
 _MenuItems[1].startInArrayIndex = 12;
 _MenuItems[2].startInArrayIndex = 24;
 _MenuItems[3].startInArrayIndex = 36;
_MainMenus[0].startIndex = 1;
_MainMenus[0].isSwitchMenuAroundRing = 1;
_MainMenus[0].stopIndex = 4;
_MainMenus[0].currentItem = _MenuItems[0];
_menuValueArray_int[0] = (readIntegerFromEEPROM(1, 0, 0x0));
_menuValueArray_int[1] = (readIntegerFromEEPROM(3, 0, 0x0));
_menuValueArray_float[0] = (readFloatFromEEPROM(5, 0, 0x0));
_menuValueArray_float[1] = (readFloatFromEEPROM(9, 0, 0x0));
}
void loop()
{bool _tempVariable_bool;
byte _tempVariable_byte;
if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}

bool  _bounceInputTmpD3 =  (digitalRead (3));

if (_bounseInputD3S) 
    {
     if (millis() >= (_bounseInputD3P + 40)) 
         {_bounseInputD3O= _bounceInputTmpD3; _bounseInputD3S=0;}
     }
else
    {
     if (_bounceInputTmpD3 != _bounseInputD3O )
         {_bounseInputD3S=1; _bounseInputD3P = millis();} 
      } 
bool  _bounceInputTmpD4 =  (digitalRead (4));

if (_bounseInputD4S) 
    {
     if (millis() >= (_bounseInputD4P + 40)) 
         {_bounseInputD4O= _bounceInputTmpD4; _bounseInputD4S=0;}
     }
else
    {
     if (_bounceInputTmpD4 != _bounseInputD4O )
         {_bounseInputD4S=1; _bounseInputD4P = millis();} 
      } 
bool  _bounceInputTmpD2 =  (digitalRead (2));

if (_bounseInputD2S) 
    {
     if (millis() >= (_bounseInputD2P + 40)) 
         {_bounseInputD2O= _bounceInputTmpD2; _bounseInputD2S=0;}
     }
else
    {
     if (_bounceInputTmpD2 != _bounseInputD2O )
         {_bounseInputD2S=1; _bounseInputD2P = millis();} 
      } 




//Плата:1
if (_gtv4) {
_dispTempLength1 = (String("A")).length();
if (_disp11oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp11oldLength = _dispTempLength1;
_lcd1.setCursor(4, 1);
_lcd1.print(String("A"));
} else {
if (_disp11oldLength > 0) {_isNeedClearDisp1 = 1; _disp11oldLength = 0;} 
}
if (_gtv3) {
_dispTempLength1 = (String("A")).length();
if (_disp9oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp9oldLength = _dispTempLength1;
_lcd1.setCursor(4, 1);
_lcd1.print(String("A"));
} else {
if (_disp9oldLength > 0) {_isNeedClearDisp1 = 1; _disp9oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = (String("A")).length();
if (_disp6oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp6oldLength = _dispTempLength1;
_lcd1.setCursor(15, 0);
_lcd1.print(String("A"));
} else {
if (_disp6oldLength > 0) {_isNeedClearDisp1 = 1; _disp6oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = (String("A")).length();
if (_disp7oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp7oldLength = _dispTempLength1;
_lcd1.setCursor(15, 1);
_lcd1.print(String("A"));
} else {
if (_disp7oldLength > 0) {_isNeedClearDisp1 = 1; _disp7oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = (String("A")).length();
if (_disp8oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp8oldLength = _dispTempLength1;
_lcd1.setCursor(4, 0);
_lcd1.print(String("A"));
} else {
if (_disp8oldLength > 0) {_isNeedClearDisp1 = 1; _disp8oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = (String("C")).length();
if (_disp16oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp16oldLength = _dispTempLength1;
_lcd1.setCursor(4, 1);
_lcd1.print(String("C"));
} else {
if (_disp16oldLength > 0) {_isNeedClearDisp1 = 1; _disp16oldLength = 0;} 
}
Key_235650101_1 = !(_bounseInputD2O);
if ( Key_235650101_1 !=oldkey_235650101_1) {
	oldkey_235650101_1 = Key_235650101_1;
	if	( Key_235650101_1 ) {
		Short_235650101_1 = 0;
		Long_235650101_1 = 0;
		K_FL_235650101_1=1;
		oldtime_235650101_1=millis();
		} else {
			if (K_FL_235650101_1){
			Short_235650101_1=1;
			keytime_235650101_1=millis();
			K_FL_235650101_1=0;
			}
		}
		}
if ((Key_235650101_1)and (!Long_235650101_1) and (K_FL_235650101_1)){
	if ((millis()-oldtime_235650101_1)>= 2000 )	{
			Long_235650101_1 = 1;
			keytime_235650101_1=millis();
			K_FL_235650101_1=0;
		}
	}
if (( Short_235650101_1 )or(  Long_235650101_1  )){
	deltatime_235650101_1=millis()-keytime_235650101_1;
	if (deltatime_235650101_1>  100  ){
		 Short_235650101_1 =0;
		 Long_235650101_1 =0;
		 K_FL_235650101_1=0;
	}
}

bool  _tmp1 = Long_235650101_1;
if (_tmp1)  { if (! _trgt1I) _trgt1 = ! _trgt1; } 
_trgt1I = _tmp1; 
_gtv2 = _trgt1;
 if (_trgt1) {
_tempVariable_bool  =  1;
 if ( ! _MenuBlock_118425010_OEIS ) {_MenuBlock_118425010_OEIS = 1;
} 
_tempVariable_byte = pgm_read_byte(&_menuParametrsArray[((_MainMenus[0].currentItem ).startInArrayIndex)+10]);
_MenuBlock_118425010_MNO = _readStringFromProgmem ((char*)pgm_read_word(&(_flprogMenuStringsArray[_tempVariable_byte - 1])));
_MenuBlock_118425010_VNO = _menuOutputValueString (0);
_MenuBlock_118425010_AMO_310615098 = pgm_read_byte(&_menuParametrsArray[(_MainMenus[0].currentItem ).startInArrayIndex]) == 1; 
_MenuBlock_118425010_AMO_209567261 = pgm_read_byte(&_menuParametrsArray[(_MainMenus[0].currentItem ).startInArrayIndex]) == 2; 
_MenuBlock_118425010_AMO_355910277 = pgm_read_byte(&_menuParametrsArray[(_MainMenus[0].currentItem ).startInArrayIndex]) == 3; 
_MenuBlock_118425010_AMO_375957480 = pgm_read_byte(&_menuParametrsArray[(_MainMenus[0].currentItem ).startInArrayIndex]) == 4; 
} else {
_tempVariable_bool  =  0;
if (_MenuBlock_118425010_OEIS){
_MenuBlock_118425010_OEIS = 0;
_menuUpdateToEEpromItems();
}
_MenuBlock_118425010_AMO_310615098 = 0;
_MenuBlock_118425010_AMO_209567261 = 0;
_MenuBlock_118425010_AMO_355910277 = 0;
_MenuBlock_118425010_AMO_375957480 = 0;
_MenuBlock_118425010_MNO = "";
_MenuBlock_118425010_VNO = "";
}
if(0) { if ( ! _MenuBlock_118425010_OMUIS) {_MenuBlock_118425010_OMUIS = 1;if (_tempVariable_bool){  _menuUpEvents(0);
_menuUpdateToEEpromItems();
}}} else {_MenuBlock_118425010_OMUIS = 0;}
if(Short_235650101_1) { if ( ! _MenuBlock_118425010_OMDIS) {_MenuBlock_118425010_OMDIS = 1;if (_tempVariable_bool){   _menuDownEvents(0);
_menuUpdateToEEpromItems();
}}} else {_MenuBlock_118425010_OMDIS = 0;}
if(!(_bounseInputD3O)) { if ( ! _MenuBlock_118425010_OVUIS) {_MenuBlock_118425010_OVUIS = 1; if (_tempVariable_bool){  _valueUpEvents(0); _MenuBlock_118425010_VUDST = millis();} }if (_tempVariable_bool){
if (_MenuBlock_118425010_VUDSM == 0) { if (_isTimer(_MenuBlock_118425010_VUDST , 600 )) {_MenuBlock_118425010_VUDSM = 1; _MenuBlock_118425010_VUDSPT = millis(); _MenuBlock_118425010_VUDPT  = 200;}}  else { if (_MenuBlock_118425010_VUDSM == 1) { if (_isTimer(_MenuBlock_118425010_VUDST , 2000 )) {_MenuBlock_118425010_VUDSM = 2;_MenuBlock_118425010_VUDPT  = 50; } } if (_isTimer(_MenuBlock_118425010_VUDSPT , _MenuBlock_118425010_VUDPT )) { _valueUpEvents(0);  _MenuBlock_118425010_VUDSPT = millis();}  }
}} else {_MenuBlock_118425010_OVUIS = 0; if( ! ( !(_bounseInputD4O))){_MenuBlock_118425010_VUDSM = 0; }}
if(!(_bounseInputD4O)) { if ( ! _MenuBlock_118425010_OVDIS) {_MenuBlock_118425010_OVDIS = 1; if (_tempVariable_bool){  _valueDownEvents(0); _MenuBlock_118425010_VUDST = millis();}} if (_tempVariable_bool){
if (_MenuBlock_118425010_VUDSM == 0) { if (_isTimer(_MenuBlock_118425010_VUDST , 600 )) {_MenuBlock_118425010_VUDSM = 1; _MenuBlock_118425010_VUDSPT = millis(); _MenuBlock_118425010_VUDPT  = 200;}}  else { if (_MenuBlock_118425010_VUDSM == 1) { if (_isTimer(_MenuBlock_118425010_VUDST , 2000 )) {_MenuBlock_118425010_VUDSM = 2;_MenuBlock_118425010_VUDPT  = 50; } } if (_isTimer(_MenuBlock_118425010_VUDSPT , _MenuBlock_118425010_VUDPT )) { _valueDownEvents(0);  _MenuBlock_118425010_VUDSPT = millis();}  }
}} else {_MenuBlock_118425010_OVDIS = 0; if( ! ( !(_bounseInputD3O))){_MenuBlock_118425010_VUDSM = 0; }}
_gtv5 = _MenuBlock_118425010_AMO_375957480;
_gtv1 = _MenuBlock_118425010_AMO_355910277;
_gtv4 = _MenuBlock_118425010_AMO_209567261;
_gtv3 = _MenuBlock_118425010_AMO_310615098;
if (_gtv2) {
_dispTempLength1 = ((_MenuBlock_118425010_VNO)).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((_MenuBlock_118425010_VNO));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}
if (_gtv2) {
_dispTempLength1 = ((_MenuBlock_118425010_MNO)).length();
if (_disp4oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp4oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((_MenuBlock_118425010_MNO));
} else {
if (_disp4oldLength > 0) {_isNeedClearDisp1 = 1; _disp4oldLength = 0;} 
}
if (_gtv1) {
_dispTempLength1 = (String("s")).length();
if (_disp10oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp10oldLength = _dispTempLength1;
_lcd1.setCursor(2, 1);
_lcd1.print(String("s"));
} else {
if (_disp10oldLength > 0) {_isNeedClearDisp1 = 1; _disp10oldLength = 0;} 
}
if (_gtv5) {
_dispTempLength1 = (String("`C")).length();
if (_disp15oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp15oldLength = _dispTempLength1;
_lcd1.setCursor(3, 1);
_lcd1.print(String("`C"));
} else {
if (_disp15oldLength > 0) {_isNeedClearDisp1 = 1; _disp15oldLength = 0;} 
}
tempADC_168854444_1=analogRead(1) ;
Rsamples_168854444_1[count_168854444_1] = (tempADC_168854444_1 *  9910ul )/(1023-tempADC_168854444_1) ;
Raverage_168854444_1=0;
for (byte i=0; i < 10 ; i++)
{Raverage_168854444_1 += Rsamples_168854444_1[i];}
 Raverage_168854444_1 /=  10 ;
count_168854444_1++ ;
if(count_168854444_1 >= 10) {count_168854444_1=0;}
for (index_168854444_1=0; pgm_read_dword(&table_168854444_1[index_168854444_1]) >  Raverage_168854444_1; index_168854444_1++ )
{if(index_168854444_1>250){index_168854444_1=0;break;}}
calcT_168854444_1=0 + (index_168854444_1 * 5);
Temperature_168854444_1 = (Raverage_168854444_1-pgm_read_dword(&table_168854444_1[index_168854444_1]))/float(pgm_read_dword(&table_168854444_1[index_168854444_1-1]) - pgm_read_dword(&table_168854444_1[index_168854444_1])) ;
Temperature_168854444_1= calcT_168854444_1 - (5 * Temperature_168854444_1);
if (!(_gtv2)) {
_dispTempLength1 = ((( _floatToStringWitRaz(Temperature_168854444_1,1)))).length();
if (_disp14oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp14oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((( _floatToStringWitRaz(Temperature_168854444_1,1))));
} else {
if (_disp14oldLength > 0) {_isNeedClearDisp1 = 1; _disp14oldLength = 0;} 
}
if((Temperature_168854444_1) > ((_menuValueArray_int[0]))) _trgs1 = 1;
if(!(_bounseInputD2O)) _trgs1 = 0;
if (_trgs1)
{ if (_tim3I) { if (_isTimer(_tim3P, _gtv6)) {_tim3O = 1;}} else {_tim3I =1; _tim3P = millis();}} else {_tim3O = 0; _tim3I = 0;}
if (_tim3O) {
_dispTempLength1 = (String("<<")).length();
if (_disp12oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp12oldLength = _dispTempLength1;
_lcd1.setCursor(5, 1);
_lcd1.print(String("<<"));
} else {
if (_disp12oldLength > 0) {_isNeedClearDisp1 = 1; _disp12oldLength = 0;} 
}
Irms_120491848_1 = emon1_120491848_1.calcIrms(1480);  // Calculate Irms_120491848_1 only
  Power_120491848_1 = Irms_120491848_1 * 230.0;
  Serial.print("Power_120491848_1");
Serial.println(Power_120491848_1);	       // Apparent power
  Serial.print(" ");
Serial.print("Irms_120491848_1");
Serial.println( Irms_120491848_1 ); 
if (!(_gtv2)) {
_dispTempLength1 = ((( _floatToStringWitRaz((_menuValueArray_float[1]),1)))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(11, 0);
_lcd1.print((( _floatToStringWitRaz((_menuValueArray_float[1]),1))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = ((( _floatToStringWitRaz((_menuValueArray_float[0]),1)))).length();
if (_disp3oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp3oldLength = _dispTempLength1;
_lcd1.setCursor(11, 1);
_lcd1.print((( _floatToStringWitRaz((_menuValueArray_float[0]),1))));
} else {
if (_disp3oldLength > 0) {_isNeedClearDisp1 = 1; _disp3oldLength = 0;} 
}
if((Irms_120491848_1) < ((_menuValueArray_float[0]))) _trgs2 = 1;
if(!(_bounseInputD2O)) _trgs2 = 0;
if (_trgs2)
{ if (_tim4I) { if (_isTimer(_tim4P, _gtv6)) {_tim4O = 1;}} else {_tim4I =1; _tim4P = millis();}} else {_tim4O = 0; _tim4I = 0;}
if (_tim4O) {
_dispTempLength1 = (String(">>")).length();
if (_disp13oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp13oldLength = _dispTempLength1;
_lcd1.setCursor(9, 1);
_lcd1.print(String(">>"));
} else {
if (_disp13oldLength > 0) {_isNeedClearDisp1 = 1; _disp13oldLength = 0;} 
}
if (!(_gtv2)) {
_dispTempLength1 = ((( _floatToStringWitRaz(Irms_120491848_1,1)))).length();
if (_disp5oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp5oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((( _floatToStringWitRaz(Irms_120491848_1,1))));
} else {
if (_disp5oldLength > 0) {_isNeedClearDisp1 = 1; _disp5oldLength = 0;} 
}
if((Irms_120491848_1) > ((_menuValueArray_float[1]))) _trgs3 = 1;
if(!(_bounseInputD2O)) _trgs3 = 0;
if (_trgs3)
{ if (_tim2I) { if (_isTimer(_tim2P, _gtv6)) {_tim2O = 1;}} else {_tim2I =1; _tim2P = millis();}} else {_tim2O = 0; _tim2I = 0;}
if (_tim2O) {
_dispTempLength1 = (String(">>")).length();
if (_disp17oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp17oldLength = _dispTempLength1;
_lcd1.setCursor(9, 0);
_lcd1.print(String(">>"));
} else {
if (_disp17oldLength > 0) {_isNeedClearDisp1 = 1; _disp17oldLength = 0;} 
}
_FreeLog1_IArr[0] = (Irms_120491848_1) > ((_menuValueArray_float[1]));
_FreeLog1_IArr[1] = (Irms_120491848_1) < ((_menuValueArray_float[0]));
_FreeLog1_IArr[2] = (Temperature_168854444_1) > ((_menuValueArray_int[0]));
_FreeLog1_Q1 = _checkFreeLogicBlockOutput(_FreeLog1_IArr, 3, _FreeLog1_Q1_StArr, 18); 
if(_FreeLog1_Q1) _trgs4 = 1;
if(!(_bounseInputD2O)) _trgs4 = 0;
if (_trgs4)
{ if (_tim1I) { if (_isTimer(_tim1P, _gtv6)) {_tim1O = 1;}} else {_tim1I =1; _tim1P = millis();}} else {_tim1O = 0; _tim1I = 0;}
digitalWrite(13, _tim1O);
_gtv6 = (1000)*((_menuValueArray_int[1]));




}
String  _floatToStringWitRaz(float value, int raz)
{
 
  return String(value,raz);
}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
String _readStringFromProgmem (char *string)
{
String result = String("");
while (pgm_read_byte(string)!='\0')
{
result=result+ char(pgm_read_byte(string));
	string++;
	}
return result;
}
 void _menuUpEvents (byte menuIndex)
{
byte tempIndex = pgm_read_byte(&_menuParametrsArray[((_MainMenus[menuIndex]).currentItem).startInArrayIndex]);
byte parIndex = pgm_read_byte(&_menuParametrsArray[ (((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+5]);
byte parentStartIndex;
byte parentStopIndex;
if (parIndex == 0) {parentStartIndex = (_MainMenus[menuIndex]).startIndex; parentStopIndex = (_MainMenus[menuIndex]).stopIndex;}
else { parentStartIndex = pgm_read_byte(&_menuParametrsArray[( (_MenuItems[parIndex - 1]).startInArrayIndex)+3]);
 parentStopIndex = pgm_read_byte(&_menuParametrsArray[( (_MenuItems[parIndex-1]).startInArrayIndex)+4]); }
if (tempIndex == parentStartIndex) {if((_MainMenus[menuIndex]).isSwitchMenuAroundRing) {(_MainMenus[menuIndex]).currentItem = _MenuItems[parentStopIndex -1]; return;} else{return;}}
(_MainMenus[menuIndex]).currentItem = _MenuItems[tempIndex - 2];
return;
}
 void _menuDownEvents (byte menuIndex)
{
byte tempIndex = pgm_read_byte(&_menuParametrsArray[((_MainMenus[menuIndex]).currentItem).startInArrayIndex]);
byte parIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+5]);
byte parentStartIndex;
byte parentStopIndex;
if (parIndex == 0) {parentStartIndex = (_MainMenus[menuIndex]).startIndex; parentStopIndex = (_MainMenus[menuIndex]).stopIndex;}
else { parentStartIndex = pgm_read_byte(&_menuParametrsArray[( (_MenuItems[parIndex-1]).startInArrayIndex)+3]);
 parentStopIndex = pgm_read_byte(&_menuParametrsArray[((_MenuItems[parIndex-1]).startInArrayIndex)+4]); }
if (tempIndex == parentStopIndex) {if((_MainMenus[menuIndex]).isSwitchMenuAroundRing) {(_MainMenus[menuIndex]).currentItem = _MenuItems[parentStartIndex -1]; return;} else{return;}}
(_MainMenus[menuIndex]).currentItem = _MenuItems[tempIndex];
return;
}
 void _valueUpEvents (byte menuIndex)
{
byte valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
byte itemType = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
byte indexMax = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+6]);
byte indexStep = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+8]);
if (itemType == 1) {if (! indexMax == 0) { if ( ! (int(pgm_read_word(&_menuConstantValuesArray_int[indexMax -1])) > int(_menuValueArray_int[valIndex -1]))) {return;} }
_menuValueArray_int[valIndex -1] = _menuValueArray_int[valIndex -1] + (pgm_read_word(&_menuConstantValuesArray_int[indexStep -1])); }
if (itemType == 7) {if (! indexMax == 0) { if ( ! (float(pgm_read_float(&_menuConstantValuesArray_float[indexMax -1])) > float(_menuValueArray_float[valIndex -1]))) {return;} }
_menuValueArray_float[valIndex -1] = _menuValueArray_float[valIndex -1] + (pgm_read_float(&_menuConstantValuesArray_float[indexStep -1])); }
}
 void _valueDownEvents (byte menuIndex)
{

byte valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
byte itemType = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
byte indexMin = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+7]);
byte indexStep = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+8]);
if (itemType == 1) { if (! indexMin == 0) { if ( ! ((int(pgm_read_word(&_menuConstantValuesArray_int[indexMin - 1]))) < int(_menuValueArray_int[valIndex - 1]))) {return;}} 
_menuValueArray_int[valIndex - 1] = _menuValueArray_int[valIndex - 1] - (pgm_read_word(&_menuConstantValuesArray_int[indexStep - 1])); }
if (itemType == 7) { if (! indexMin == 0) { if ( ! ((float(pgm_read_float(&_menuConstantValuesArray_float[indexMin - 1]))) < float(_menuValueArray_float[valIndex - 1]))) {return;}} 
_menuValueArray_float[valIndex - 1] = _menuValueArray_float[valIndex - 1] - (pgm_read_float(&_menuConstantValuesArray_float[indexStep - 1])); }
}
 String _menuOutputValueString (byte menuIndex)
{
byte itemType = pgm_read_byte(&_menuParametrsArray[ (((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
byte valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
byte indexMin = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+7]);
byte indexMax = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+6]);
if( valIndex == 0){ return "";}
byte convFormat = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+9]);
if(itemType == 1) { return _convertNamber(itemType, convFormat, valIndex, indexMax, indexMin);}
if(itemType == 7) { return _convertFloat(itemType, convFormat, valIndex, indexMax, indexMin);}
return "";
}
 void _menuUpdateToEEpromItems()
{
(updateIntegerToEEPROM(1, 0, 0x0, ((_menuValueArray_int[0]))));
(updateIntegerToEEPROM(3, 0, 0x0, ((_menuValueArray_int[1]))));
(updateFloatToEEPROM(5, 0, 0x0, ((_menuValueArray_float[0]))));
(updateFloatToEEPROM(9, 0, 0x0, ((_menuValueArray_float[1]))));
}
String _convertNamber(byte itemType, byte convFormat, byte valIndex, byte indexMax, byte indexMin)
{
if (itemType== 1) {
if (convFormat == 4) { return String((_menuValueArray_int[valIndex - 1 ]),DEC);}
if (convFormat == 5) { return String((_menuValueArray_int[valIndex - 1]),HEX);}
if (convFormat == 6) { return String((_menuValueArray_int[valIndex -1]),BIN);}
}
if (itemType== 7) {
if (convFormat == 4) { return String((_menuValueArray_float[valIndex - 1 ]),DEC);}
if (convFormat == 5) { return String((_menuValueArray_float[valIndex - 1]),HEX);}
if (convFormat == 6) { return String((_menuValueArray_float[valIndex -1]),BIN);}
}
}
String _convertFloat(byte itemType, byte convFormat, byte valIndex , byte indexMax, byte indexMin)
{
return String((_menuValueArray_float[valIndex -1]),convFormat);
}
bool _checkFreeLogicBlockOutput(bool inArray[], int inArraySize, bool stArray[], int stArraySize)
{ int inIndex = 0;
  bool result = 1;
  for (int i = 0; i < stArraySize; i = i + 1)
  {
   if (!(inArray[inIndex] == stArray[i])) { result = 0;}
   inIndex ++;
   if (inIndex == inArraySize)
     {
     if (result) { return 1;} else {result = 1;}
     inIndex = 0;
     }
  }
  return 0;
}
 byte readByteFromEEPROM(int addres, byte bitAddres, byte chipAddres)
{
return EEPROM.read(addres);
}
void updateByteToEEPROM(int addres, byte bitAddres, byte chipAddres, byte value)
{
return EEPROM.update(addres, value);
}
 int readIntegerFromEEPROM(int addres, byte bitAddres, byte chipAddres)
{
byte hight = readByteFromEEPROM( addres,  bitAddres,  chipAddres);
byte low = readByteFromEEPROM( (addres+1),  bitAddres,  chipAddres);
return  word(hight, low);
}
 void updateIntegerToEEPROM(int addres, byte bitAddres, byte chipAddres, int value)
{
updateByteToEEPROM( addres,  bitAddres,  chipAddres, highByte(value));
updateByteToEEPROM( (addres+1),  bitAddres,  chipAddres, lowByte(value));
}
 float readFloatFromEEPROM(int addres, byte bitAddres, byte chipAddres)
{
byte x[4];
for(byte i = 0; i < 4; i++) { x[i] = readByteFromEEPROM( (addres+i),  bitAddres,  chipAddres);}
float *y = (float *)&x;
return y[0];
}
 void updateFloatToEEPROM(int addres, byte bitAddres, byte chipAddres, float value)
{
byte *x = (byte *)&value;
for(byte i = 0; i < 4; i++) {updateByteToEEPROM( (addres+i),  bitAddres,  chipAddres, x[i]);}
}
